<?php

class CategoryProductPricingFunctionalities {

    public static function sp_alter_product_price_as_per_category_product_type( $price , $product ) {
        $user_id    = get_current_user_id() ;
        $product_id = sumo_sd_get_product_id( $product ) ;
        $price      = self::sp_get_price_by_sumo_categoryproduct( $price , $product ) ;
        return max( $price , 0 ) ;
    }

    public static function sumo_check_sale_price( $unique_id , $product ) {
        if ( $product->get_sale_price() > 0 ) {
            $check = get_option( 'sumo_pricing_rule_fields_for_cat_pro' ) ;
            if ( is_array( $check ) && ! empty( $check ) ) {
                if ( array_key_exists( $unique_id , $check ) ) {
                    if ( isset( $check[ $unique_id ][ 'sumo_apply_this_rule_for_sale' ] ) ) {
                        return true ;
                    }
                }
            }
        } else {
            return true ;
        }
    }

    public static function sumo_day_filter_for_categoryproduct_pricing( $unique_id ) {
        $current_day = strtolower( date( 'l' ) ) ;
        $week_days   = array ( 'monday' , 'tuesday' , 'wednesday' , 'thursday' , 'friday' , 'saturday' , 'sunday' ) ;
        foreach ( $week_days as $day ) {
            if ( $current_day == $day ) {
                $check = get_option( 'sumo_pricing_rule_fields_for_cat_pro' ) ;
                if ( is_array( $check ) && ! empty( $check ) ) {
                    if ( array_key_exists( $unique_id , $check ) ) {
                        if ( isset( $check[ $unique_id ][ 'sumo_pricing_rule_week_' . $day ] ) ) {
                            return true ;
                        }
                    }
                }
            }
        }
    }

    public static function sp_get_price_by_sumo_categoryproduct( $price , $product ) {
        $price_array         = array () ;
        $DataforFreeShipping = array () ;
        $product_id          = sumo_sd_get_product_id( $product ) ;
        $user_id             = is_user_logged_in() ? get_current_user_id() : 0 ;
        $rp_rule_array       = get_option( 'sumo_pricing_rule_fields_for_cat_pro' , true ) ;
        if ( ! empty( $rp_rule_array ) && is_array( $rp_rule_array ) ) {
            foreach ( $rp_rule_array as $unique_id => $each_array ) {
                if ( isset( $each_array[ 'sumo_enable_the_rule' ] ) ) {
                    if ( self::sumo_check_sale_price( $unique_id , $product ) ) {
                        if ( self::sumo_day_filter_for_categoryproduct_pricing( $unique_id ) ) {
                            $fromdate = $each_array[ 'sumo_pricing_from_datepicker' ] != "" ? strtotime( $each_array[ 'sumo_pricing_from_datepicker' ] ) : NULL ;
                            $todate   = $each_array[ 'sumo_pricing_to_datepicker' ] != '' ? strtotime( $each_array[ 'sumo_pricing_to_datepicker' ] ) : strtotime( date_i18n( 'd-m-Y' ) ) ;
                            if ( sumo_function_for_date_filter( $fromdate , $todate ) ) {
                                $newarray_for_product_and_category_check = array (
                                    'product_type'      => $each_array[ 'sumo_pricing_apply_to_products' ] ,
                                    'included_products' => isset( $each_array[ 'sumo_pricing_apply_to_include_products' ] ) ? $each_array[ 'sumo_pricing_apply_to_include_products' ] : '' ,
                                    'excluded_products' => isset( $each_array[ 'sumo_pricing_apply_to_exclude_products' ] ) ? $each_array[ 'sumo_pricing_apply_to_exclude_products' ] : '' ,
                                    'included_category' => isset( $each_array[ 'sumo_pricing_apply_to_include_category' ] ) ? $each_array[ 'sumo_pricing_apply_to_include_category' ] : array () ,
                                    'excluded_category' => isset( $each_array[ 'sumo_pricing_apply_to_exclude_category' ] ) ? $each_array[ 'sumo_pricing_apply_to_exclude_category' ] : array () ,
                                    'included_tag'      => isset( $each_array[ 'sumo_pricing_apply_to_include_tag' ] ) ? $each_array[ 'sumo_pricing_apply_to_include_tag' ] : array () ,
                                    'excluded_tag'      => isset( $each_array[ 'sumo_pricing_apply_to_exclude_tag' ] ) ? $each_array[ 'sumo_pricing_apply_to_exclude_tag' ] : array ()
                                        ) ;
                                $newarray_for_user_and_userrole_check    = array (
                                    'check_type'         => $each_array[ 'sumo_pricing_apply_for_user_type' ] ,
                                    'included_users'     => isset( $each_array[ 'sumo_pricing_apply_to_include_users' ] ) ? $each_array[ 'sumo_pricing_apply_to_include_users' ] : '' ,
                                    'excluded_users'     => isset( $each_array[ 'sumo_pricing_apply_to_exclude_users' ] ) ? $each_array[ 'sumo_pricing_apply_to_exclude_users' ] : '' ,
                                    'included_userroles' => isset( $each_array[ 'sumo_pricing_apply_to_include_users_role' ] ) ? $each_array[ 'sumo_pricing_apply_to_include_users_role' ] : array () ,
                                    'excluded_userroles' => isset( $each_array[ 'sumo_pricing_apply_to_exclude_users_role' ] ) ? $each_array[ 'sumo_pricing_apply_to_exclude_users_role' ] : array () ,
                                        ) ;
                                $merge_array                             = array ( 'include_membership_plans' => isset( $each_array[ 'sumo_pricing_apply_to_include_memberplans' ] ) ? $each_array[ 'sumo_pricing_apply_to_include_memberplans' ] : array () ) ;
                                $check_user_or_member                    = class_exists( 'SUMOMemberships' ) && sumo_get_membership_levels() ? array_merge( $newarray_for_user_and_userrole_check , $merge_array ) : $newarray_for_user_and_userrole_check ;
                                if ( sumo_function_for_product_and_category_filter( sumo_dynamic_pricing_product_id_from_other_lang( $product_id ) , $newarray_for_product_and_category_check ) ) {
                                    if ( sumo_function_for_user_and_userrole_filter( $user_id , $unique_id , $check_user_or_member , $each_array ) ) {
                                        $pricing_type = $each_array[ 'sumo_pricing_type' ] ;
                                        $value        = ( float ) $each_array[ 'sumo_discount_value' ] ;
                                        if ( $pricing_type == '1' ) {
                                            $altered_price = ( float ) ($price - (($price * $value) / 100)) ;
                                        } elseif ( $pricing_type == '2' ) {
                                            $altered_price = ( float ) ($price - $value) ;
                                        } else {
                                            $altered_price = ( float ) $value ;
                                        }
                                        $price_array[ $unique_id ]             = $altered_price ;
                                        $DataforFreeShipping[ $altered_price ] = $unique_id ;
                                    }
                                }
                            }
                        }
                    }
                }
            }
            WC()->session->set( 'applied_catpro_discount_rule_id' , $DataforFreeShipping ) ;
            if ( ! empty( $price_array ) ) {
                $priority = get_option( 'sumo_cat_pro_pricing_priority_settings' , true ) ;
                if ( $priority == '1' ) {
                    $price = reset( $price_array ) ;
                } elseif ( $priority == '2' ) {
                    $price = end( $price_array ) ;
                } elseif ( $priority == '3' ) {
                    $price = max( $price_array ) ;
                } elseif ( $priority == '4' ) {
                    $price = min( $price_array ) ;
                }
            }
        }
        return $price ;
    }

}

new CategoryProductPricingFunctionalities() ;
